// Copyright 2022 ZORALab Enterprise (hello@zoralab.com)
// Copyright 2022 "Holloway" Chew, Kean Ho (hollowaykeanho@gmail.com)
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// thelper is a test helpers complimenting the standard `testing` package.
//
// OBJECTIVES
//
// Its primary goal is to extend the `testing` package by:
//   1. facilitating large scale unit testing (>1000 lines of codes test cases).
//   2. respecting test codes like the source codes.
//   3. simplify any common assertions.
//
// PROBLEMS
//
// The biggest problem for testing in Go is that no-one mentions about large
// scale testing and continuous test development. Most of the tutorial guides
// only mention table-driven approach and only show the basic and that's it.
//
// In reality, package grows incrementally over time and as it grows larger, the
// existing test approaches is a nightmare to maintain.
//
// APPROACHES
//
// thelper is still using table-driven test approach like any other gophers.
// The differences are:
//   1. how thelper organizes the source codes and segments of test codes;
//   2. use simulation test approach instead of direct testing approach;
//   3. the use of switches.
//
// This way, it does not limits tester's flexibility in testing while still
// able some systematic test implementations across various packages.
//
// WHITE PAPERS
//
//   1. http://dx.doi.org/10.13140/RG.2.2.36308.76166
package thelper
