// Copyright 2022 ZORALab Enterprise (hello@zoralab.com)
// Copyright 2022 "Holloway" Chew, Kean Ho (hollowaykeanho@gmail.com)
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package thelper

import (
	"testing"
)

func TestExpectUIDCorrectness(t *testing.T) {
	scenarios := testTHelperScenarios()

	for i, s := range scenarios {
		if s.testType != testTHelperExpectUIDCorrectness {
			continue
		}

		// prepare
		th := NewTHelper(t)
		s.prepareController(th)
		s.prepareQuietMode(th)
		s.prepareMissingContainers(th)
		index, uid, startFromZero := s.prepareUIDSample()

		// test
		err, ok := s.inSubject.(error)
		if !ok {
			err = nil
		}

		ret := th.ExpectUIDCorrectness(index, uid, startFromZero)

		// assert
		s.assertUIDCorrectness(t, i)
		s.assertExpectUIDCorrectness(t, th, ret)
		s.assertExistence(t, th, ret)
		s.logf(t, th, ret, err)
	}
}
